import 'dart:typed_data';

/// Codec that encodes and decodes the type [T] for the text and binary protocol.
/// Can be used to handle non-standard (custom and extension) types.
abstract class PostgresTypeCodec<T> {
  final String name;

  PostgresTypeCodec(this.name);

  bool canEncode(dynamic value) => value is T;

  String encodeText(T value);
  Uint8List encodeBytes(T value);
  T decodeBytes(Uint8List bytes);
}
